const pi =3.1415926535897931;
var SW = GetScreenWidth();
var SH = GetScreenHeight();
var Bullets = [];
var Enemies = [];
var BulletLaunched = false;
var mx,my, mdx, mdy, lx = SW / 2, ly = SH / 2
var LaunchAngle = -pi / 2
var f = LoadFont("font.rfn");
var shinyfont = LoadFont("font_shiny.rfn");
var df = LoadFont("simple.rfn");

var counter = 0;
var looper = 0;

var trans = CreateColor(0,0,0,0);
var red = CreateColor(255,0,0,128);
var blue = CreateColor(0,0,255,128);
var white = CreateColor(255,255,255);
var hpcolor = CreateColor(0,0,0,50);
var hpcolor2 = CreateColor(255,50,50,150);
var ch_color = CreateColor(255,0,0,128);

var Crosshair = CreateSurface(11,11,ch_color);
var LevelLimit = 300;
var CurrentNum = 0;
var Points = 0;
var LevelComplete = false;
var InterlevelTime = 10000;
var InterlevelCounter = 0;
var SpawnNew
var DoWorldExplosion = false;

var playerHP = 100;
var playerMaxHP = 100;

var Spaceship = GetSystemArrow();
function game() {
	var t
	while (true) {
		t = GetTime();
		mx = GetMouseX();
		my = GetMouseY();
		mdx = (mx - lx)
		mdy = (my - ly)
		LaunchAngle = Math.atan2(mdy,mdx);
		
		ApplyColorMask(white);
		if(playerHP <= 0){
			Abort("You've lost! However, you already won "+Points+" points!");
		}
		
		f.drawText(5,5,"Enemies: "+CurrentNum+"/"+LevelLimit);
		
		lx2 = lx + 10 * Math.cos(LaunchAngle);
		ly2 = ly + 10 * Math.sin(LaunchAngle);
		Spaceship.rotateBlit(lx,ly,LaunchAngle);
		Rectangle(lx, ly - 5, (playerHP / playerMaxHP) * 50, 3, hpcolor);
		Rectangle(lx, ly - 3, 50, 1, hpcolor);
		Line(lx,ly,lx2,ly2,red);
		
		if(IsKeyPressed(KEY_A)){
			if(lx > 0) lx -= 5
		}
		if(IsKeyPressed(KEY_W)){
			if(ly > 0) ly -= 5
		}
		if(IsKeyPressed(KEY_D)){
			if(lx < SW) lx += 5
		}
		if(IsKeyPressed(KEY_S)){
			if(ly < SH) ly += 5
		}
	
		if(IsMouseButtonPressed(MOUSE_LEFT)){
			//if(!BulletLaunched){
				LaunchBullet(LaunchAngle);
				//LaunchBullet(LaunchAngle);
				//LaunchBullet(LaunchAngle);
			//}
		}else{
			BulletLaunched = false;
		}
		
		if(IsKeyPressed(KEY_CTRL)){
			Enemies.push(new Enemy({}));
		}
		
		if(IsKeyPressed(KEY_ALT)){
			DoWorldExplosion = true;
		}
	
		counter = Bullets.length
		looper = 0
		while(looper < counter){
			Bullets[looper].update();
			Bullets[looper].render();
			++looper
		}
		
		counter = Enemies.length
		looper = 0
		while(looper < counter){
			if(!Enemies[looper].dead){
				Enemies[looper].update();
				Enemies[looper].render();
			}
			++looper
		}
		
		// Spawning
		if(Math.random() < 0.07 && CurrentNum < LevelLimit){
			if(LevelLimit - CurrentNum < 101){
				Enemies.push(new Enemy({num: LevelLimit-CurrentNum}));
			}else{
				if(Math.random() < 0.03){
					Enemies.push(new Enemy({num: 0}));
				}else{
					Enemies.push(new Enemy({}));
				}
			}
			CurrentNum += Enemies[Enemies.length-1].num;
		}
		
		if(DoWorldExplosion){
			ApplyColorMask(white);
			Enemies = [];
			Bullets = [];
			DoWorldExplosion = false;
			continue;
		}
		
		if(CurrentNum >= LevelLimit){
			LevelComplete = true;
			for(i=0;i<Enemies.length;i++){
				if(!Enemies[i].dead){
					LevelComplete = false;
					break;
				}
			}
			// Level reset
			if(LevelComplete == true){
				LevelLimit += 400 + Math.floor(Math.random() * 550)
				Enemies = [];
				Bullets = [];
			}
		}
		
		if(LevelComplete){
			InterlevelCounter += 33;
			f.drawTextBox(5,35,400,SH,0,"Level complete!")
			if(InterlevelCounter > InterlevelTime){
				LevelComplete = false
				InterlevelCounter = 0;
			}
		}
		
		
		// Cleanup task
		for(i=0;i<Enemies.length;i++){
			if(Enemies[i].dead){
				Enemies.splice(i,1)
				i++
			}
		}
		for(i=0;i<Bullets.length;i++){
			if(!Bullets[i].visible){
				Bullets.splice(i,1)
				i++
			}
		}
		
		
		FlipScreen();
		while(GetTime() < t + 33){}
	}
}

function Enemy(data){
	this.x = data.x || Math.random() * SW;
	this.y = data.y || -1;
	this.mainv = data.v || 1 + (Math.random() * 5);
	this.v = this.mainv
	this.runa = 1 + Math.random()
	this.rund = this.runa * 0.75
	if(this.rund > 1){
		this.rund = Math.random();
	}
	this.isRunning = false;
	this.a = 1;
	this.angle = data.angle || Math.random() * 2 * pi
	this.num = data.num || Math.floor(Math.random() * 100);
	this.font = f;
	this.w = this.font.getStringWidth(this.num+"");
	this.h = this.font.getHeight();
	this.img = CreateSurface(this.w,this.h,trans);
	this.img.drawText(this.font,0,0,this.num+"");
	this.img = this.img.createImage();
	this.dead = false;
	this.shield = true;
	this.shieldhealth = 50;
	this.hp = (this.num * 0.5) + (this.num * Math.random());
	this.maxhp = this.hp;
	this.hasBeenDamaged = false;
	if(this.num == 0 || this.num == 1){
		this.font = shinyfont
		this.hp = 500;
		this.maxhp = 500;
		this.img = CreateSurface(this.w,this.h,trans);
		this.img.drawText(this.font,0,0,this.num+"");
		this.img = this.img.createImage();
		this.shieldhealth = 500;
	}
	this.prime = false;
	for(x=0;x<primes.length;x++){
		if(this.num == primes[x]){
			this.prime = true;
		}
	}
}

Enemy.prototype.render = function(){
	this.img.rotateBlit(this.x,this.y,this.angle);
	if(this.shield) df.drawText(this.x+20,this.y+20,this.shieldhealth);
	if(this.hasBeenDamaged){
		Rectangle(this.x,this.y-5,(this.hp / this.maxhp) * 50,3,hpcolor2);
	}else{
		Rectangle(this.x,this.y-5,(this.hp / this.maxhp) * 50,3,hpcolor);
	}
	//this.img.blit(this.x,this.y);
}

Enemy.prototype.update = function(){
	this.v *= this.a;
	this.vx = this.v * Math.cos(this.angle);
	this.vy = this.v * Math.sin(this.angle);
	if(this.v > 50){
		this.v = 50;
	}
	this.x += this.vx;
	this.y += this.vy;
	this.targetangle = Math.atan2(ly - this.y,lx - this.x );
	
	if(Math.random() < 0.05){
		this.fire(lx,ly);
	}
	
	if(this.hasBeenDamaged){
		this.v *= this.runa
		this.isRunning = true;
	}else{
		this.isRunning = false;
	}
	
	if(!this.isRunning && this.v > this.mainv){
		this.v *= this.rund
	}
	
	if(this.x < 0) this.x = SW - 1
	if(this.x > SW) this.x = 0
	if(this.y < 0) this.y = SH - 1
	if(this.y > SH) this.y = 0
	
	if(this.shieldhealth < 0){
		this.shield = false;
	}
	
	/*
	if(this.prime){
		this.angle = this.targetangle;
	}
	*/
	
	this.hasBeenDamaged = false;
	for(n=0;n<Bullets.length;n++){
		if(Bullets[n].visible && !Bullets[n].evil){
			if(Math.abs(Bullets[n].x - this.x) < this.w && Math.abs(Bullets[n].y - this.y) < this.h){
				
				this.hasBeenDamaged = true;
				if(this.shield){
					this.shieldhealth -= 10
				}else{
					if(this.hp < 0){
						this.explode();
					}else{
						this.hp -= Bullets[n].damage
					}
				}
			}
		}
	}
	
	// Shield ceiling
	if(this.shieldhealth <= 0){
		this.shield = false;
	}
}

var primes = [2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,57,59,61,67,71,73,79,83,87,89,91,97];
Enemy.prototype.explode = function(){
	for(x=0;x<primes.length;x++){
		if(this.num == primes[x]){
			this.dead = true;
			return;
		}
	}
				
				
	this.dead = true;
	var decendants = [];
	var now = this.num;
	var done = false;
	if(this.num == 1 || this.num == 0){
		DoWorldExplosion = true;
	}else{
		while(!done){
			for(x=0;x<primes.length;x++){
				if(now == primes[x]){
					decendants.push(primes[x]);
					done = true;
					break;
				}
				if(now % primes[x] == 0){
					decendants.push(primes[x]);
					now = now / primes[x];
					break;
				}
				
			}
			
		}
	}
	Points += this.num
	for(x=0;x<decendants.length;x++){
		Enemies.push(new Enemy({
			num: decendants[x],
			x: this.x,
			y: this.y
		}));
	}
}

Enemy.prototype.fire = function(x,y){
	Bullets.push(new Bullet({
		angle: this.targetangle,
		x: this.x,
		y: this.y,
		color: blue,
		evil: true,
		v: 1,
		length: 10,
		spread: pi / 5
	}));
}

function Bullet(data){
	this.x = data.x || lx;
	this.y = data.y || ly;
	this.color = data.color || red;
	this.v = data.v || 3;
	this.a = 1 + (Math.random() * 0.3);
	this.d = 0.9
	this.anglespread = data.spread || 0 // pi / 5 
	this.angle = data.angle || 0
	this.angle = this.angle + ((Math.random() * this.anglespread) - 0.5 * this.anglespread)
	this.visible = true;
	this.evil = data.evil || false;
	this.length = data.length || 5;
	this.damage = data.damage || 10
}

Bullet.prototype.render = function(){
	if(this.visible){
		//Rectangle(this.x,this.y,5,5,this.color);
		Line(this.x,this.y,this.x2,this.y2,this.color);
	}
}

Bullet.prototype.update = function(){
	if(!this.visible) return false;
	this.v *= this.a;
	this.vx = this.v * Math.cos(this.angle);
	this.vy = this.v * Math.sin(this.angle);
	this.x += this.vx;
	this.y += this.vy;
	
	if(this.v > 100) this.v *= this.d
	
	this.x2 = this.x + this.length * Math.cos(this.angle);
	this.y2 = this.y + this.length * Math.sin(this.angle);
	
	if(Math.abs(this.x - lx) < 20 && Math.abs(this.y - ly) < 20 && this.evil){
		this.visible = false;
		playerHP -= this.damage
	}
	
	if(this.x < -10 || this.x > SW + 10 || this.y < -10 || this.y > SH + 10) this.visible = false;
}

function LaunchBullet(angle){
	Bullets.push(new Bullet({
		angle: angle,
		length: 10,
		anglespread: 0
	}));
	BulletLaunched = true;
}


/*
    if (IsKeyPressed(KEY_UP)) v += 0.01; 
    else if (IsKeyPressed(KEY_DOWN)) v -= 0.01; else {
      if (v > 0) v -= 0.01;
      if (v < 0) v += 0.01;
    }
    if (IsKeyPressed(KEY_UP)) v += 0.01; else if (v > 0) v -= 0.01;
    if (IsKeyPressed(KEY_LEFT)) angle = angle - pi/90;
    if (IsKeyPressed(KEY_RIGHT)) angle = angle + pi/90;
    
        vx = v * Math.cos(angle);
    vy = v * Math.sin(angle);
    x = x + vx;
    y += vy;

*/